using Optim

include("hs52_prob.jl")

############################ def. Penalità e Lagr.aumentato #############################
rho = 1.0
mu  = zeros(3)

P(x) = f(x) + rho*(h1(x)^2 + h2(x)^2 + h3(x)^2)
La(x) = f(x) + mu[1]*h1(x) + mu[2]*h2(x) + mu[3]*h3(x) + rho*(h1(x)^2 + h2(x)^2 + h3(x)^2)
function grad_P!(x,gp)
	g = nabla_f(x) + 2*rho*nabla_h(x)*transpose(h(x))
	gp[1] = g[1]
	gp[2] = g[2]
	gp[3] = g[3]
	gp[4] = g[4]
	gp[5] = g[5]
	
	return nothing
end
function grad_La!(x,gl)
	g = nabla_f(x) + nabla_h(x)*mu + 2*rho*nabla_h(x)*transpose(h(x))
	gl[1] = g[1]
	gl[2] = g[2]
	gl[3] = g[3]
	gl[4] = g[4]
	gl[5] = g[5]
	
	return nothing
end
#########################################################################################


xzero  = [2. , 2. , 2., 2., 2.]
#xzero  = [  -0.0849703
#  0.0283234
#  0.506067 
# -0.44942  
#  0.0283234
#]

xkpen  = xzero
xklagr = xzero
Pconv  = false
Lconv  = false
tol    = 1.e-1
g      = zeros(5)

@printf("it        rho            P    \n")
@printf("------------------------------\n")

for k = 0:300
	if ~Pconv
		
		rho = 0.1*1.1^k

		xstart = xkpen
		res = optimize(P,grad_P!,xstart,g_tol = tol,f_tol = -1.0,show_trace = false)
		xkpen = res.minimum
		grad_P!(xkpen,g)		
		@printf("%2d %13.6e %13.6e %13.6e\n",k,rho,P(xkpen),norm(g))
		if tol < 1.e-8 && norm(h(xkpen)) < 1.e-6
			Pconv = true
		end
		tol = max(tol/10,1.e-9)
		mu  = rho*transpose(h(xkpen))
	else
		break
	end
end

println()
println(f(xkpen)," ",f(xkpen)*349)
println(h(xkpen))
println(xkpen," ",xkpen*349)
println(transpose(mu))

print("Hit return key to continue")
readline()

tol = 1.e-1

for k = 0:300
	if ~Lconv
		
		rho = 0.1*1.1^k

		xstart = xklagr
		res = optimize(La,grad_La!,xstart,g_tol = tol,show_trace = false)
		xklagr = res.minimum
		grad_La!(xklagr,g)		
		@printf("%2d %13.6e %13.6e %13.6e\n",k,rho,La(xklagr),norm(g))
		if tol < 1.e-8 && norm(h(xklagr)) < 1.e-8
			Lconv = true
		end
		tol = max(tol/10,1.e-9)
		mu  = mu + rho*transpose(h(xklagr))
	else
		break
	end
end

println()
println(f(xklagr)," ",f(xklagr)*349)
println(h(xklagr))
println(xklagr," ",xklagr*349)
println(transpose(mu))

nothing
