using Optim

include("hs56_prob.jl")

############################ def. Penalità e Lagr.aumentato #############################
rho = 1.0

P(x) = f(x) + rho*(h1(x)^2 + h2(x)^2 + h3(x)^2 + h4(x)^2)
function grad_P!(x,gp)
	g = nabla_f(x) + 2*rho*nabla_h(x)*transpose(h(x))
	for i = 1:length(x)
		gp[i] = g[i]
	end
end
#########################################################################################

xzero  = [1. , 1. , 1., asin(sqrt(1/4.2)), asin(sqrt(1/4.2)), asin(sqrt(1/4.2)), asin(sqrt(5/7.2))]
xkpen  = xzero
Pconv  = false
tol    = 1.0

@printf("it        rho            P    \n")
@printf("------------------------------\n")

for k = 0:300
	rho = 10+0.1*1.1^k
	if ~Pconv
		@printf("%2d %13.6e %13.6e\n",k,rho,P(xkpen))
		xstart = xkpen
		res = optimize(P,grad_P!,xstart,g_tol = tol,show_trace = false)
		xkpen = res.minimum
		if tol < 1.e-7 && norm(h(xkpen)) < 1.e-6
			Pconv = true
		end
		tol = max(tol/2,1.e-8)
	else
		break
	end
end

println(f(xkpen))
println(h(xkpen))
nothing
